SystemOrganization addCategory: #TutorialBrowser!

GLMExamplesBrowser subclass: #TutorialExamplesBrowser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TutorialBrowser'!

!TutorialExamplesBrowser methodsFor: 'private' stamp: 'StephanEggermont 6/28/2012 23:16'!
exampleBrowserForPragma: each in: aClass
	^super exampleBrowserForPragma: each in: GLMBasicExamples
! !

!TutorialExamplesBrowser methodsFor: 'as yet unclassified' stamp: 'StephanEggermont 7/2/2012 15:30'!
exampleIn: composer
	composer dynamic
		title: 'Browser';
		display: [ :exampleClass :examplePragma | self exampleBrowserForPragma: examplePragma in: exampleClass ];
		act: [ :dynamic | 
				dynamic cachedPresentation presentations first panes first presentations first openTree ] 
			entitled: 'View browser tree'.
	composer smalltalkCode
		title: 'My Source code';
		act: [ :text :exampleClass :examplePragma | StandardToolSet browse: GLMBasicExamples  selector: examplePragma selector ]
			icon: GLMUIThemeExtraIcons glamorousBrowse
			entitled: 'Browse';
		smalltalkClass: [ :exampleClass | exampleClass ];
		doItReceiver: [ :exampleClass | exampleClass ];
		display: [ :exampleClass :pragma | GLMBasicExamples sourceCodeAt: pragma selector ]! !

Object subclass: #Tutorial
	instanceVariableNames: 'root presentationMode'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TutorialBrowser'!

!Tutorial class methodsFor: 'accessing' stamp: 'DiegoLont 11/20/2012 10:51'!
browser
	^self browser: nil! !

!Tutorial class methodsFor: 'accessing' stamp: 'DiegoLont 11/20/2012 10:51'!
browser: aBoolean
	^((self new)
		presentationMode: aBoolean;
		browser) title: self title! !

!Tutorial class methodsFor: 'public' stamp: 'StephanEggermont 6/28/2012 18:33'!
open
	^self browser openOn: self new tutorial! !

!Tutorial class methodsFor: 'public' stamp: 'DiegoLont 11/20/2012 10:51'!
openPresentation
	^(self browser: true)
		openOn: self new tutorial! !

!Tutorial class methodsFor: 'accessing' stamp: 'StephanEggermont 6/28/2012 17:17'!
title
	^'Tutorial'! !

!Tutorial methodsFor: 'accessing' stamp: 'DiegoLont 11/20/2012 10:45'!
browser
	"self new browser openOn: GLMBasicExamples"

	| browser |
	browser := GLMTabulator new.
	browser
		column: #titles;
		column: #example span: 4.
	browser transmit
		to: #titles;
		andShow: [ :a | a tree
				display: [ :aSymbolArray | aSymbolArray ];
				children: [ :aSymbol | (self perform: aSymbol) children];
				format: [ :aSymbol | (self perform: aSymbol) title]].
	browser transmit
		to: #example;
		from: #titles;
		andShow: [ :a | a dynamic with: [:some :selection |
				(self presentationFor: selection) show value: some]  ].
	^ browser! !

!Tutorial methodsFor: 'accessing' stamp: 'DiegoLont 11/20/2012 10:43'!
presentationFor: aSymbol
	^(self perform: aSymbol)
		presentationMode: self presentationMode;
		yourself! !

!Tutorial methodsFor: 'accessing' stamp: 'DiegoLont 11/20/2012 10:26'!
presentationMode
	presentationMode ifNil: [ ^false ].
	^presentationMode! !

!Tutorial methodsFor: 'accessing' stamp: 'DiegoLont 11/20/2012 10:26'!
presentationMode: aBoolean
	presentationMode := aBoolean! !

Object subclass: #TutorialItem
	instanceVariableNames: 'title children childClass presentationMode'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TutorialBrowser'!

TutorialItem subclass: #TutorialCustom
	instanceVariableNames: 'presentation'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TutorialBrowser'!

!TutorialCustom methodsFor: 'accessing' stamp: 'StephanEggermont 6/28/2012 21:07'!
presentation
	^ presentation! !

!TutorialCustom methodsFor: 'accessing' stamp: 'StephanEggermont 6/28/2012 21:07'!
presentation: anObject
	presentation := anObject! !

!TutorialCustom methodsFor: 'accessing' stamp: 'StephanEggermont 6/28/2012 21:08'!
show
	^[ :a | a custom: presentation value]! !

TutorialItem subclass: #TutorialCustomAndSource
	instanceVariableNames: 'presentation'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TutorialBrowser'!

!TutorialCustomAndSource methodsFor: 'accessing' stamp: 'StephanEggermont 6/29/2012 00:05'!
presentation
	^ presentation! !

!TutorialCustomAndSource methodsFor: 'accessing' stamp: 'StephanEggermont 6/29/2012 00:05'!
presentation: anObject
	presentation := anObject! !

!TutorialCustomAndSource methodsFor: 'accessing' stamp: 'StephanEggermont 6/29/2012 00:12'!
show
	^[ :a | a stackedVerticallyArrangement.
		 a custom: presentation value.
		 a text
			title: 'Source';
			display: [:each | presentation printString].
		]! !

TutorialItem subclass: #TutorialCustomAndText
	instanceVariableNames: 'text textTitle presentation smalltalkClass'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TutorialBrowser'!

!TutorialCustomAndText methodsFor: 'accessing' stamp: 'DiegoLont 6/29/2012 10:57'!
presentation
	^ presentation! !

!TutorialCustomAndText methodsFor: 'accessing' stamp: 'DiegoLont 6/29/2012 10:57'!
presentation: anObject
	presentation := anObject! !

!TutorialCustomAndText methodsFor: 'accessing' stamp: 'StephanEggermont 1/26/2014 16:43'!
show
	^[ :a |
		| tag |
		a stackedVerticallyArrangement.
		a custom: presentation value.
		self smalltalkClass
			ifNil: [ tag := a text ]
			ifNotNil: [ tag := a smalltalkCode
				smalltalkClass: self smalltalkClass ].
		tag
			title: self textTitle;
			format: self text ]! !

!TutorialCustomAndText methodsFor: 'accessing' stamp: 'DiegoLont 6/29/2012 11:21'!
smalltalkClass
	^ smalltalkClass! !

!TutorialCustomAndText methodsFor: 'accessing' stamp: 'DiegoLont 6/29/2012 11:21'!
smalltalkClass: anObject
	smalltalkClass := anObject! !

!TutorialCustomAndText methodsFor: 'accessing' stamp: 'DiegoLont 6/29/2012 10:59'!
text
	^ text! !

!TutorialCustomAndText methodsFor: 'accessing' stamp: 'DiegoLont 6/29/2012 10:57'!
text: anObject
	text := anObject! !

!TutorialCustomAndText methodsFor: 'accessing' stamp: 'DiegoLont 6/29/2012 10:59'!
textTitle
	textTitle ifNil: [ ^'Description' ].
	^ textTitle! !

!TutorialCustomAndText methodsFor: 'accessing' stamp: 'DiegoLont 6/29/2012 10:59'!
textTitle: anObject
	textTitle := anObject! !

TutorialItem subclass: #TutorialExercise
	instanceVariableNames: 'text textTitle presentation smalltalkClass assignment target methodSelector'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TutorialBrowser'!

!TutorialExercise methodsFor: 'accessing' stamp: 'DiegoLont 6/29/2012 14:39'!
assignment
	^ assignment! !

!TutorialExercise methodsFor: 'accessing' stamp: 'DiegoLont 6/29/2012 14:39'!
assignment: anObject
	assignment := anObject! !

!TutorialExercise methodsFor: 'accessing' stamp: 'DiegoLont 11/23/2012 10:44'!
browser
	| browser |
	browser := GLMTabulator new.
	browser column: [ :c | c row: #main; row: #source ] span: 2;
		column: #assignment.
	browser transmit to: #main; andShow: [ :b |
		b custom: self presentation ].
	browser transmit to: #source; andShow: [ :b |
		self showSourceOn: b ].
	browser transmit from: #source port: #acceptedCode; to: #main; andShow: [ :a | 
		a dynamic with: [:some :selection | self parseCode: selection some: some ] ].
	browser transmit to: #assignment; andShow: [ :b |
		b text
		display: self assignment;
		format: [ :par | (Text string: title attribute: (TextFontChange font4)), (String crlf), par ] ].
	browser startOn: self target.
	^browser! !

!TutorialExercise methodsFor: 'initialization' stamp: 'DiegoLont 11/23/2012 11:10'!
buildText
	| source startIndex stopIndex |
	source := (self smalltalkClass methodDict at: self methodSelector) getSource.
	startIndex := source findString: '"start exercise'.
	startIndex <= 0 ifTrue: [ ^source ].
	stopIndex := source findString: '"stop exercise"'.
	stopIndex <= startIndex ifTrue: [ ^source ].
	^String streamContents: [ :s |
		| first |
		first := true.
		(source copyFrom: startIndex + 15 to: stopIndex -1) linesDo: [ :line |
			first
				ifTrue: [ 
					line ifNotEmpty: [
						s nextPutAll: line allButLast; crlf.
						first := false ] ]
				ifFalse: [ s nextPutAll: line; crlf ] ] ]! !

!TutorialExercise methodsFor: 'actions' stamp: 'DiegoLont 11/23/2012 11:18'!
createSourceFrom: aText
	| source startIndex stopIndex |
	source := (self smalltalkClass methodDict at: self methodSelector) getSource.
	startIndex := source findString: '"start exercise'.
	startIndex <= 0 ifTrue: [ ^aText ].
	stopIndex := source findString: '"stop exercise"'.
	stopIndex <= startIndex ifTrue: [ ^aText ].
	^String streamContents: [ :s |
		| first |
		s nextPutAll: (source copyFrom: 1 to: startIndex +15);
			crlf.
		first := true.
		aText asString linesDo: [ :line |
			s nextPutAll: line.
			first ifTrue: [ 
				s nextPut: $".
				first := false ].
			s crlf ].
		s nextPutAll: (source copyFrom: stopIndex to: source size) ]
! !

!TutorialExercise methodsFor: 'accessing' stamp: 'DiegoLont 10/30/2012 13:18'!
methodSelector
	^ methodSelector! !

!TutorialExercise methodsFor: 'accessing' stamp: 'DiegoLont 10/30/2012 13:18'!
methodSelector: anObject
	methodSelector := anObject! !

!TutorialExercise methodsFor: 'actions' stamp: 'DiegoLont 11/23/2012 11:11'!
parseCode: aText some: some
	self smalltalkClass compile: (self createSourceFrom: aText) string classified: #exercise.
	presentation := nil.
	^some custom: self presentation! !

!TutorialExercise methodsFor: 'accessing' stamp: 'DiegoLont 10/30/2012 13:19'!
presentation
	^presentation ifNil: [ presentation := self smalltalkClass new perform: self methodSelector ]! !

!TutorialExercise methodsFor: 'accessing' stamp: 'DiegoLont 10/30/2012 13:18'!
presentation: aBrowser
	presentation := aBrowser! !

!TutorialExercise methodsFor: 'accessing' stamp: 'DiegoLont 6/29/2012 14:46'!
show
	^[ :a | a custom: self browser ]! !

!TutorialExercise methodsFor: 'accessing' stamp: 'DiegoLont 11/23/2012 10:44'!
showSourceOn: pane
	| tag |
	self smalltalkClass
		ifNil: [ tag := pane text ]
		ifNotNil: [ tag := pane smalltalkCode
			smalltalkClass: self smalltalkClass;
			populate: #acceptedCode icon: GLMUIThemeExtraIcons glamorousAccept on: $s entitled: 'Accept' with: [ :bla | bla text ] ].
	tag
		title: self textTitle;
		display: self text ! !

!TutorialExercise methodsFor: 'accessing' stamp: 'DiegoLont 6/29/2012 14:39'!
smalltalkClass
	^ smalltalkClass! !

!TutorialExercise methodsFor: 'accessing' stamp: 'DiegoLont 6/29/2012 14:39'!
smalltalkClass: anObject
	smalltalkClass := anObject! !

!TutorialExercise methodsFor: 'accessing' stamp: 'DiegoLont 6/29/2012 15:05'!
target
	^ target! !

!TutorialExercise methodsFor: 'accessing' stamp: 'DiegoLont 6/29/2012 15:05'!
target: anObject
	target := anObject! !

!TutorialExercise methodsFor: 'accessing' stamp: 'DiegoLont 11/23/2012 10:46'!
text
	^ text ifNil: [ text := self buildText ]! !

!TutorialExercise methodsFor: 'accessing' stamp: 'DiegoLont 6/29/2012 14:39'!
text: anObject
	text := anObject! !

!TutorialExercise methodsFor: 'accessing' stamp: 'DiegoLont 6/29/2012 14:39'!
textTitle
	textTitle ifNil: [ ^'Description' ].
	^ textTitle! !

!TutorialExercise methodsFor: 'accessing' stamp: 'DiegoLont 6/29/2012 14:39'!
textTitle: anObject
	textTitle := anObject! !

TutorialItem subclass: #TutorialForm
	instanceVariableNames: 'form'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TutorialBrowser'!

!TutorialForm methodsFor: 'accessing' stamp: 'StephanEggermont 10/29/2012 21:13'!
form
	^ form! !

!TutorialForm methodsFor: 'accessing' stamp: 'StephanEggermont 10/29/2012 21:13'!
form: anObject
	form := anObject! !

!TutorialForm methodsFor: 'accessing' stamp: 'StephanEggermont 10/29/2012 21:18'!
show
	^[ :a | a morph display: [: par | form value]]! !

!TutorialItem methodsFor: 'accessing' stamp: 'StephanEggermont 6/29/2012 09:18'!
childClass
	^ childClass! !

!TutorialItem methodsFor: 'accessing' stamp: 'StephanEggermont 6/29/2012 09:18'!
childClass: anObject
	childClass := anObject! !

!TutorialItem methodsFor: 'accessing' stamp: 'StephanEggermont 6/28/2012 17:14'!
children
	^ children! !

!TutorialItem methodsFor: 'accessing' stamp: 'StephanEggermont 6/28/2012 20:51'!
children: anObject
	children := anObject ifNil: [children := OrderedCollection new]! !

!TutorialItem methodsFor: 'accessing' stamp: 'StephanEggermont 11/29/2012 14:54'!
fontWithSize: aSize
	^TextFontReference toFont: (LogicalFont familyName: 'Nanum Gothic' pointSize: aSize)! !

!TutorialItem methodsFor: 'accessing' stamp: 'DiegoLont 11/20/2012 10:51'!
presentationMode
	^ presentationMode! !

!TutorialItem methodsFor: 'accessing' stamp: 'DiegoLont 11/20/2012 10:40'!
presentationMode: aBoolean 
	presentationMode := aBoolean! !

!TutorialItem methodsFor: 'accessing' stamp: 'StephanEggermont 1/26/2014 16:16'!
show
	^[ :a | 
		a text 
			format: [:par | (Text string: self title attribute: self titleFont) ]].! !

!TutorialItem methodsFor: 'accessing' stamp: 'StephanEggermont 6/28/2012 17:14'!
title
	^ title! !

!TutorialItem methodsFor: 'accessing' stamp: 'StephanEggermont 6/28/2012 17:14'!
title: anObject
	title := anObject! !

!TutorialItem methodsFor: 'accessing' stamp: 'StephanEggermont 11/29/2012 14:51'!
titleFont
	self presentationMode ifTrue: [ ^self titleFontWithSize: 24 ].
	^self fontWithSize: 12! !

!TutorialItem methodsFor: 'accessing' stamp: 'DiegoLont 11/20/2012 10:35'!
titleFont: aFont
	titleFont := aFont! !

!TutorialItem methodsFor: 'accessing' stamp: 'StephanEggermont 11/29/2012 14:52'!
titleFontWithSize: aSize
	^TextFontReference toFont: (LogicalFont familyName: 'Nanum Pen Script' pointSize: aSize)! !

TutorialItem subclass: #TutorialText
	instanceVariableNames: 'text bullets'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TutorialBrowser'!

!TutorialText methodsFor: 'accessing' stamp: 'StephanEggermont 11/29/2012 14:54'!
bodyFont
	self presentationMode ifTrue: [ ^self fontWithSize: 12 ].
	^self fontWithSize: 9! !

!TutorialText methodsFor: 'accessing' stamp: 'DiegoLont 11/20/2012 13:07'!
bullets
	^bullets! !

!TutorialText methodsFor: 'accessing' stamp: 'DiegoLont 11/20/2012 13:08'!
bullets: aString
	bullets := aString! !

!TutorialText methodsFor: 'accessing' stamp: 'StephanEggermont 1/26/2014 16:17'!
show
	^[ :a | 
		a text 
			format: [:par | (Text string: title attribute: self titleFont), (String crlf), self transformedText  ]].! !

!TutorialText methodsFor: 'accessing' stamp: 'StephanEggermont 6/28/2012 17:22'!
text
	^ text! !

!TutorialText methodsFor: 'accessing' stamp: 'StephanEggermont 6/28/2012 17:22'!
text: anObject
	text := anObject! !

!TutorialText methodsFor: 'accessing' stamp: 'DiegoLont 11/20/2012 13:20'!
transformedText
	|richText |
	self bullets ifNil: [ ^self transformedText: self text ].
	self presentationMode ifFalse: [ ^self transformedText: self text ].
	^self transformedText: self bullets! !

!TutorialText methodsFor: 'accessing' stamp: 'DiegoLont 11/20/2012 13:20'!
transformedText: aText
	|richText |
	richText := Text new.
	aText lines do: [ :line |
		| printString bold |
		printString := line trimBoth.
		bold := nil.
		(line beginsWith: '-') ifTrue: [
			richText append: ' - '.
			richText addAttribute: (TextAnchor new
				anchoredMorph: GLMUIThemeExtraIcons glamorousRedCircle asMorph;
				yourself) from: richText size -1 to: richText size.
			printString := (line copyFrom: 2 to: line size) trimBoth  ].
		(line beginsWith: '*') ifTrue: [
			bold := richText size.
			printString := (line copyFrom: 2 to: line size) trimBoth  ].
		richText append: printString.
		bold ifNotNil: [ richText makeBoldFrom: bold to: richText size ] ] separatedBy: [ richText append: String crlf ].
	richText addAttribute: self bodyFont.
	^richText! !
